VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NemoX engine Tutrial 5"
   ClientHeight    =   5625
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7020
   LinkTopic       =   "Form1"
   ScaleHeight     =   5625
   ScaleWidth      =   7020
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'========================================
'Tutorial# 5 :Adding Environnment Skybox'
'========================================
'
'
'Welcome to the NemoX engine Tutorial Series
'
'This is the Tutorial# 5 :Adding Environnment Skybox
'for questions and remark go to
'the Engine Website:http://perso.wanadoo.fr/malakoff/index.htm
'
'Or mail me at Johna_pop@yahoo.fr
'
'If you are interresting of making demos,sample,tuts for NemoX engine
'or you want to help me mail Me Johna_pop@yahoo.fr
'
'======================================================
'MAKE SURE YOU HAVE DOWNLOAD THE ENGINE FILES AND HAVE
'SEEN THE TUT #1 at http://perso.wanadoo.fr/malakoff/index.htm
'project section
'=======================================================
'
'
'KEY Arrow to Move left,right,Forward,BackWard
'KEY Numpad 8/2  turn UP/DOWN
'KEY Numpad +/- to move camera UP/DOWN
'


'The first thing to do is to Declarate the Object that
'we will use for this demo


'The Main One is The NemoX renderer
Dim Nemo As NemoX

'we're gonna use a Nemo class for rendering a mesh or polygons
'we use cNemo_Mesh class

Dim Mesh As cNemo_Mesh


'we will need a quick acces to very important and useful functions
Dim Tool As cNemo_Tools




'====NEW OBJECT====
Dim Sky As cNemo_SkyBox




Private Sub Form_Load()
 
  
  Me.Show
  Me.Refresh

  'call the initializer sub
  Call InitEngine
  
  
    'make geometry
  Call BuilGeometry
  
  'call the main game Loop
   Call gameLoop
   
 
 
End Sub




'we build our mesh here
Sub BuilGeometry()
        'allocate memory for our meshbuilder
        Set Mesh = New cNemo_Mesh
        
        
        'adding a plane surface for a simple floor$
        
        'first off very important we pass a texture to the meshbuilder
        Mesh.Add_Texture (App.Path + "\Relief_8.jpg")
        Mesh.Add_WallFloor Tool.Vector(-5000, -1, -5000), Tool.Vector(5000, -1, 5000), 10, 10, 0
        
        Mesh.Add_Light 254, 251, 0, 800, Tool.Vector(500, 500, 0), 50
        
        
        'then we build our mesh
        Mesh.BuilMesh
        
        
        
        
        '============NEW CODE========
        ' setting up the skybox environnment
        '===========================
        
        'allocate memory for the sky object
        Set Sky = New cNemo_SkyBox
        'initialize our sky dimensions
        Sky.Init_SkyBox 10, 10, 10
        
        'we add each sky texture part here
        Sky.Add_SkyBOX NEMO_SKY_LEFT, App.Path + "\rockyvalley\rockyvalley_lf.jpg"
        Sky.Add_SkyBOX NEMO_SKY_RIGHT, App.Path + "\rockyvalley\rockyvalley_rt.jpg"
        Sky.Add_SkyBOX NEMO_SKY_BACK, App.Path + "\rockyvalley\rockyvalley_bk.jpg"
        Sky.Add_SkyBOX NEMO_SKY_FRONT, App.Path + "\rockyvalley\rockyvalley_ft.jpg"
        Sky.Add_SkyBOX NEMO_SKY_DOWN, App.Path + "\rockyvalley\rockyvalley_dn.jpg"
        Sky.Add_SkyBOX NEMO_SKY_TOP, App.Path + "\rockyvalley\rockyvalley_up.jpg"
        
        
        'we rescale the sky here to fit our scene
        'environnement
        Sky.Set_Scale 8500, 8500, 8500
        

End Sub




'we will used that sub for the engine initialization

Sub InitEngine()

 'first thing allocate memory for the main Object
  
  Set Nemo = New NemoX
  
  Set Tool = New cNemo_Tools


'we use this method
'now we allow the user to choose options
'32/16 bit backbuffer
  
  If Not (Nemo.INIT_ShowDeviceDLG(Form1.hWnd)) Then
   End 'terminate here if error
  End If
  
  
  'set the back clearcolor
  Nemo.BackBuffer_ClearCOLOR = &HFFC0C0C0
  
  
  'set some parameters
  Nemo.Set_ViewFrustum 1, 15000, 3.14 / 4
  Nemo.Set_light True
  
  'set our camera
  Nemo.Camera_set_EYE Tool.Vector(0, 15, 0)
  
  
End Sub



'this sub is the main loop for a game or 3d apllication
Sub gameLoop()

            'loop untill player press 'ESCAPE'
      Nemo.Set_EngineRenderState D3DRS_ZENABLE, 1
    Do
            
               '=====Keyboard handler can be added here
               Call GetKey
               DoEvents
               
               
               
               'start the 3d renderer
               Nemo.Begin3D
                     '===============ADD game rendering mrthod here
               
              
               'render the sky
               Sky.RenderSky
               
               'draw our floor
               Mesh.Render
               
               
               
               
               
               'show the FPS at pixel(5,10) color White
               Nemo.Draw_Text "FPS:" + Str(Nemo.Framesperseconde), 5, 10, &HFFFF0000
               'Nemo.Draw_Text "Position X=" + Str(Nemo.Camera_GetPosition.x), 5, 25, &HFFFFFFFF
               'Nemo.Draw_Text "Position Y=" + Str(Nemo.Camera_GetPosition.y), 5, 40, &HFFFFFFFF
               'Nemo.Draw_Text "Position Z=" + Str(Nemo.Camera_GetPosition.z), 5, 55, &HFFFFFFFF
               
               
               Nemo.End3D
               'end the 3d renderer
            
            'check the player keyPressed
    Loop Until Nemo.Get_KeyPress(NEMO_KEY_ESCAPE)
            
            
    Call EndGame

End Sub



'----------------------------------------
'Name: GetKey
'----------------------------------------
Sub GetKey()



   'just Rotate left and Right
If Nemo.Get_KeyPress(NEMO_KEY_LEFT) Then _
    Nemo.Camera_Turn_Left 1.5 / 50
If Nemo.Get_KeyPress(NEMO_KEY_RIGHT) Then _
    Nemo.Camera_Turn_Right 1.5 / 50
    
    
    'just move Forward and Backward
    If Nemo.Get_KeyPress(NEMO_KEY_UP) Then _
    Nemo.Camera_Move_Foward 1
    If Nemo.Get_KeyPress(NEMO_KEY_RCONTROL) Then _
    Nemo.Camera_Move_Foward 10
   If Nemo.Get_KeyPress(NEMO_KEY_DOWN) Then _
    Nemo.Camera_Move_Backward 1


   'just move uP and Down
  If Nemo.Get_KeyPress(NEMO_KEY_ADD) Then _
    Nemo.Camera_Strafe_UP 1
  If Nemo.Get_KeyPress(NEMO_KEY_SUBTRACT) Then _
    Nemo.Camera_Strafe_DOWN 1


      'to rotate UP/DOWN
     If Nemo.Get_KeyPress(NEMO_KEY_NUMPAD8) Then
        Nemo.Camera_Turn_UP 1 / 50
    End If
    If Nemo.Get_KeyPress(NEMO_KEY_NUMPAD2) Then _
        Nemo.Camera_Turn_DOWN 1 / 50
        
        'to move 0,8,-8
    If Nemo.Get_KeyPress(NEMO_KEY_SPACE) Then _
     Nemo.Camera_SetPosition Vector(0#, 8#, -8#), _
                                    Vector(0#, 8#, 500#)
    
    'to take a snapshot
    If Nemo.Get_KeyPress(NEMO_KEY_S) Then _
     Nemo.Take_SnapShot App.Path + "\Shot.bmp"




End Sub



Sub EndGame()
 'end of the demo
            Nemo.Free  'free resources used by the engine
            End
End Sub



